Loading...
Searching...
No Matches
elastix::ConjugateGradientFRPR< TElastix > Class Template Reference
Components » Optimizers

`#include <elxConjugateGradientFRPR.h>`

## Detailed Description

template<class TElastix>
class elastix::ConjugateGradientFRPR< TElastix >

The ConjugateGradientFRPR class.

This component is based on the itkFRPROptimizer. This is a Fletcher-Reeves conjugate gradient optimizer, in combination with an exact (dBrent) line search, based on the description in Numerical Recipes in C++

This optimizer support the NewSamplesEveryIteration option. It requests new samples upon every derivative evaluation, but actually this makes no sense for a conjugate gradient optimizer. So, think twice before using it.

Note
  It prints out no stop conditions, since the itk superclass does not generate them.
  It considers line search iterations as elastix iterations.

Parameters

  Optimizer: Select this optimizer as follows:
  (Optimizer "ConjugateGradientFRPR")

  MaximumNumberOfIterations: The maximum number of iterations in each resolution.
  example: (MaximumNumberOfIterations 100 100 50)
  Default value: 100.

  MaximumNumberOfLineSearchIterations: The maximum number of iterations in each resolution.
  example: (MaximumNumberOfIterations 10 10 5)
  Default value: 10.

  StepLength: Set the length of the initial step tried by the line seach, used to bracket the minimum.
  example: (StepLength 2.0 1.0 0.5)
  Default value: 1.0.

  ValueTolerance: Convergence is declared if:

example: (ValueTolerance 0.001 0.00001 0.000001)
Default value: 0.00001.

Parameters
  LineSearchStepTolerance: Convergence of the line search is declared if:

where:
= current mininum of the gain
= current brackets around the minimum
example: (LineSearchStepTolerance 0.001 0.00001 0.000001)
Default value: 0.00001.

Definition at line 74 of file elxConjugateGradientFRPR.h.

Inheritance diagram for elastix::ConjugateGradientFRPR< TElastix >:
[legend]

## Public Types

using | ConstPointer = itk::SmartPointer<const Self>
using | DerivativeType = SingleValuedNonLinearOptimizer::DerivativeType
using | ITKBaseType = typename Superclass2::ITKBaseType
using | Pointer = itk::SmartPointer<Self>
using | Self = ConjugateGradientFRPR
using | Superclass1 = itk::FRPROptimizer
using | Superclass2 = OptimizerBase<TElastix>
Public Types inherited from elastix::OptimizerBase< TElastix >
using | ElastixType
using | ITKBaseType = itk::Optimizer
using | ParametersType = typename ITKBaseType::ParametersType
using | RegistrationType
using | Self = OptimizerBase
using | Superclass = BaseComponentSE<TElastix>
Public Types inherited from elastix::BaseComponentSE< TElastix >
using | ElastixType = TElastix
using | RegistrationType = typename ElastixType::RegistrationBaseType
using | Self = BaseComponentSE
using | Superclass = BaseComponent

## Public Member Functions

void | AfterEachIteration () override
void | AfterEachResolution () override
void | AfterRegistration () override
void | BeforeEachResolution () override
void | BeforeRegistration () override
| elxClassNameMacro ("ConjugateGradientFRPR")
virtual const char * | GetClassName () const
virtual const double & | GetCurrentDerivativeMagnitude ()
virtual const double & | GetCurrentSearchDirectionMagnitude ()
virtual const double & | GetCurrentStepLength ()
virtual bool | GetLineBracketing () const
virtual bool | GetLineOptimizing () const
| ITK_DISALLOW_COPY_AND_MOVE (ConjugateGradientFRPR)
void | SetInitialPosition (const ParametersType &param) override
Public Member Functions inherited from elastix::OptimizerBase< TElastix >
void | AfterRegistrationBase () override
void | BeforeEachResolutionBase () override
ITKBaseType * | GetAsITKBaseType ()
const ITKBaseType * | GetAsITKBaseType () const
| ITK_DISALLOW_COPY_AND_MOVE (OptimizerBase)
virtual void | SetCurrentPositionPublic (const ParametersType &param)
virtual void | SetSinusScales (double amplitude, double frequency, unsigned long numberOfParameters)
Public Member Functions inherited from elastix::BaseComponentSE< TElastix >
void | AddTargetCellToIterationInfo (const char *const name)
const Configuration * | GetConfiguration () const
ElastixType * | GetElastix () const
auto & | GetIterationInfoAt (const char *const name)
RegistrationType * | GetRegistration () const
| ITK_DISALLOW_COPY_AND_MOVE (BaseComponentSE)
void | RemoveTargetCellFromIterationInfo (const char *const name)
void | SetConfiguration (const Configuration *_arg)
void | SetElastix (ElastixType *_arg)
Public Member Functions inherited from elastix::BaseComponent
virtual void | AfterEachIterationBase ()
virtual void | AfterEachResolutionBase ()
virtual int | BeforeAll ()
virtual int | BeforeAllBase ()
virtual void | BeforeRegistrationBase ()
virtual const char * | elxGetClassName () const
const char * | GetComponentLabel () const
| ITK_DISALLOW_COPY_AND_MOVE (BaseComponent)
| itkTypeMacroNoParent (BaseComponent)
void | SetComponentLabel (const char *label, unsigned int idx)

## Static Public Member Functions

static Pointer | New ()
Static Public Member Functions inherited from elastix::BaseComponent
template<typename TBaseComponent>
static auto | AsITKBaseType (TBaseComponent *const baseComponent) -> decltype(baseComponent->GetAsITKBaseType())
static void | InitializeElastixExecutable ()
static bool | IsElastixLibrary ()

## Protected Member Functions

void | BracketedLineOptimize (double ax, double bx, double cx, double fa, double fb, double fc, double *extX, double *extVal, ParametersType &tempCoord) override
| ConjugateGradientFRPR ()
void | GetValueAndDerivative (ParametersType &p, double *val, ParametersType *xi) override
void | LineBracket (double *ax, double *bx, double *cx, double *fa, double *fb, double *fc, ParametersType &tempCoord) override
void | LineOptimize (ParametersType *p, ParametersType &xi, double *val, ParametersType &tempCoord) override
virtual void | SetLineBracketing (bool _arg)
virtual void | SetLineOptimizing (bool _arg)
| ~ConjugateGradientFRPR () override=default
Protected Member Functions inherited from elastix::OptimizerBase< TElastix >
virtual bool | GetNewSamplesEveryIteration () const
| OptimizerBase ()=default
virtual void | SelectNewSamples ()
| ~OptimizerBase () override=default
Protected Member Functions inherited from elastix::BaseComponentSE< TElastix >
| BaseComponentSE ()=default
| ~BaseComponentSE () override=default
Protected Member Functions inherited from elastix::BaseComponent
| BaseComponent ()=default
virtual | ~BaseComponent ()=default

## Protected Attributes

double | m_CurrentDerivativeMagnitude
double | m_CurrentSearchDirectionMagnitude
double | m_CurrentStepLength
Protected Attributes inherited from elastix::BaseComponentSE< TElastix >
Configuration::ConstPointer | m_Configuration {}
itk::WeakPointer< TElastix > | m_Elastix {}
RegistrationType * | m_Registration {}

## Private Member Functions

const char * | DeterminePhase () const

## Private Attributes

| elxOverrideGetSelfMacro
bool | m_LineBracketing
bool | m_LineOptimizing

## Additional Inherited Members

Protected Types inherited from elastix::OptimizerBase< TElastix >
using | SettingsVectorType = typename std::vector<SettingsType>
Static Protected Member Functions inherited from elastix::OptimizerBase< TElastix >
static void | PrintSettingsVector (const SettingsVectorType &settings)

## Member Typedef Documentation

## ConstPointer

template<class TElastix>

using elastix::ConjugateGradientFRPR< TElastix >::ConstPointer = itk::SmartPointer<const Self>

Definition at line 86 of file elxConjugateGradientFRPR.h.

## DerivativeType

template<class TElastix>

using elastix::ConjugateGradientFRPR< TElastix >::DerivativeType = SingleValuedNonLinearOptimizer::DerivativeType

Definition at line 103 of file elxConjugateGradientFRPR.h.

## ITKBaseType

template<class TElastix>

using elastix::ConjugateGradientFRPR< TElastix >::ITKBaseType = typename Superclass2::ITKBaseType

Definition at line 108 of file elxConjugateGradientFRPR.h.

## Pointer

template<class TElastix>

using elastix::ConjugateGradientFRPR< TElastix >::Pointer = itk::SmartPointer<Self>

Definition at line 85 of file elxConjugateGradientFRPR.h.

## Self

template<class TElastix>

using elastix::ConjugateGradientFRPR< TElastix >::Self = ConjugateGradientFRPR

Standard ITK.

Definition at line 82 of file elxConjugateGradientFRPR.h.

## Superclass1

template<class TElastix>

using elastix::ConjugateGradientFRPR< TElastix >::Superclass1 = itk::FRPROptimizer

Definition at line 83 of file elxConjugateGradientFRPR.h.

## Superclass2

template<class TElastix>

using elastix::ConjugateGradientFRPR< TElastix >::Superclass2 = OptimizerBase<TElastix>

Definition at line 84 of file elxConjugateGradientFRPR.h.

## Constructor & Destructor Documentation

## ConjugateGradientFRPR()

template<class TElastix>

elastix::ConjugateGradientFRPR< TElastix >::ConjugateGradientFRPR | ( |  | ) |

protected

## ~ConjugateGradientFRPR()

template<class TElastix>

elastix::ConjugateGradientFRPR< TElastix >::~ConjugateGradientFRPR | ( |  | ) |

override protected default

## Member Function Documentation

## AfterEachIteration()

template<class TElastix>

void elastix::ConjugateGradientFRPR< TElastix >::AfterEachIteration | ( |  | ) |

override virtual

Reimplemented from elastix::BaseComponent.

## AfterEachResolution()

template<class TElastix>

void elastix::ConjugateGradientFRPR< TElastix >::AfterEachResolution | ( |  | ) |

override virtual

Reimplemented from elastix::BaseComponent.

## AfterRegistration()

template<class TElastix>

void elastix::ConjugateGradientFRPR< TElastix >::AfterRegistration | ( |  | ) |

override virtual

Reimplemented from elastix::BaseComponent.

## BeforeEachResolution()

template<class TElastix>

void elastix::ConjugateGradientFRPR< TElastix >::BeforeEachResolution | ( |  | ) |

override virtual

Reimplemented from elastix::BaseComponent.

## BeforeRegistration()

template<class TElastix>

void elastix::ConjugateGradientFRPR< TElastix >::BeforeRegistration | ( |  | ) |

override virtual

Methods to set parameters and print output at different stages in the registration process.

Reimplemented from elastix::BaseComponent.

## BracketedLineOptimize()

template<class TElastix>

void elastix::ConjugateGradientFRPR< TElastix >::BracketedLineOptimize | ( | double | ax,
|  | double | bx,
|  | double | cx,
|  | double | fa,
|  | double | fb,
|  | double | fc,
|  | double * | extX,
|  | double * | extVal,
|  | ParametersType & | tempCoord )

override protected

Given a bracketing triple of points and their function values, returns a bounded extreme. These values are in parameter space, along the current line and wrt the current origin set via SetLine. Optimization terminates based on MaximumIteration, StepTolerance, or ValueTolerance. Implemented as Brent line optimers from NRC.

This implementation sets the LineOptimizing flag to 'true', calls the the superclass's implementation, stores extX as the current step length, and sets the LineOptimizing flag to 'false' again.

## DeterminePhase()

template<class TElastix>

const char * elastix::ConjugateGradientFRPR< TElastix >::DeterminePhase | ( |  | ) | const

private

## elxClassNameMacro()

template<class TElastix>

elastix::ConjugateGradientFRPR< TElastix >::elxClassNameMacro | ( | "ConjugateGradientFRPR< TElastix >" |  | ) |

Name of this class.

## GetClassName()

template<class TElastix>

virtual const char * elastix::ConjugateGradientFRPR< TElastix >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented from elastix::OptimizerBase< TElastix >.

## GetCurrentDerivativeMagnitude()

template<class TElastix>

virtual const double & elastix::ConjugateGradientFRPR< TElastix >::GetCurrentDerivativeMagnitude | ( |  | ) |

virtual

Return the magnitude of the cached derivative

## GetCurrentSearchDirectionMagnitude()

template<class TElastix>

virtual const double & elastix::ConjugateGradientFRPR< TElastix >::GetCurrentSearchDirectionMagnitude | ( |  | ) |

virtual

Get the magnitude of the line search direction

## GetCurrentStepLength()

template<class TElastix>

virtual const double & elastix::ConjugateGradientFRPR< TElastix >::GetCurrentStepLength | ( |  | ) |

virtual

Get the current gain

## GetLineBracketing()

template<class TElastix>

virtual bool elastix::ConjugateGradientFRPR< TElastix >::GetLineBracketing | ( |  | ) | const

virtual

## GetLineOptimizing()

template<class TElastix>

virtual bool elastix::ConjugateGradientFRPR< TElastix >::GetLineOptimizing | ( |  | ) | const

virtual

Check if the optimizer is currently Bracketing the minimum, or is optimizing along a line

## GetValueAndDerivative()

template<class TElastix>

void elastix::ConjugateGradientFRPR< TElastix >::GetValueAndDerivative | ( | ParametersType & | p,
|  | double * | val,
|  | ParametersType * | xi )

override protected

Get the value of the n-dimensional cost function at this scalar step distance along the current line direction from the current line origin. Line origin and distances are set via SetLine.

This implementation calls the Superclass' implementation and caches the computed derivative's magnitude. Besides, it invokes the SelectNewSamples method.

## ITK_DISALLOW_COPY_AND_MOVE()

template<class TElastix>

elastix::ConjugateGradientFRPR< TElastix >::ITK_DISALLOW_COPY_AND_MOVE | ( | ConjugateGradientFRPR< TElastix > |  | ) |

## LineBracket()

template<class TElastix>

void elastix::ConjugateGradientFRPR< TElastix >::LineBracket | ( | double * | ax,
|  | double * | bx,
|  | double * | cx,
|  | double * | fa,
|  | double * | fb,
|  | double * | fc,
|  | ParametersType & | tempCoord )

override protected

The LineBracket routine from NRC. Uses current origin and line direction (from SetLine) to find a triple of points (ax, bx, cx) that bracket the extreme "near" the origin. Search first considers the point StepLength distance from ax. IMPORTANT: The value of ax and the value of the function at ax (i.e., fa), must both be provided to this function.

This implementation sets the LineBracketing flag to 'true', calls the superclass' implementation, stores bx as the current step length, invokes an iteration event, and sets the LineBracketing flag to 'false'

## LineOptimize()

template<class TElastix>

void elastix::ConjugateGradientFRPR< TElastix >::LineOptimize | ( | ParametersType * | p,
|  | ParametersType & | xi,
|  | double * | val,
|  | ParametersType & | tempCoord )

override protected

store the line search direction's (xi) magnitude and call the superclass' implementation.

## New()

template<class TElastix>

Pointer elastix::ConjugateGradientFRPR< TElastix >::New | ( |  | ) |

static

Method for creation through the object factory.

## SetInitialPosition()

template<class TElastix>

void elastix::ConjugateGradientFRPR< TElastix >::SetInitialPosition | ( | const ParametersType & | param | ) |

override

Override the SetInitialPosition.

## SetLineBracketing()

template<class TElastix>

virtual void elastix::ConjugateGradientFRPR< TElastix >::SetLineBracketing | ( | bool | _arg | ) |

protected virtual

## SetLineOptimizing()

template<class TElastix>

virtual void elastix::ConjugateGradientFRPR< TElastix >::SetLineOptimizing | ( | bool | _arg | ) |

protected virtual

Set if the optimizer is currently bracketing the minimum, or is optimizing along a line

## Field Documentation

## elxOverrideGetSelfMacro

template<class TElastix>

elastix::ConjugateGradientFRPR< TElastix >::elxOverrideGetSelfMacro

private

Definition at line 215 of file elxConjugateGradientFRPR.h.

## m_CurrentDerivativeMagnitude

template<class TElastix>

double elastix::ConjugateGradientFRPR< TElastix >::m_CurrentDerivativeMagnitude

protected

To store the latest computed derivative's magnitude

Definition at line 150 of file elxConjugateGradientFRPR.h.

## m_CurrentSearchDirectionMagnitude

template<class TElastix>

double elastix::ConjugateGradientFRPR< TElastix >::m_CurrentSearchDirectionMagnitude

protected

Variable to store the line search direction magnitude

Definition at line 153 of file elxConjugateGradientFRPR.h.

## m_CurrentStepLength

template<class TElastix>

double elastix::ConjugateGradientFRPR< TElastix >::m_CurrentStepLength

protected

the current gain

Definition at line 156 of file elxConjugateGradientFRPR.h.

## m_LineBracketing

template<class TElastix>

bool elastix::ConjugateGradientFRPR< TElastix >::m_LineBracketing

private

Definition at line 218 of file elxConjugateGradientFRPR.h.

## m_LineOptimizing

template<class TElastix>

bool elastix::ConjugateGradientFRPR< TElastix >::m_LineOptimizing

private

Definition at line 217 of file elxConjugateGradientFRPR.h.

Generated on 1768596610 for elastix by 1.15.0 |